org.restlet.representation

## Class ReaderRepresentation

- java.lang.Object
- - org.restlet.representation.Variant
  - - org.restlet.representation.RepresentationInfo
    - - org.restlet.representation.Representation
      - - org.restlet.representation.CharacterRepresentation
        - - org.restlet.representation.ReaderRepresentation

    public class ReaderRepresentation
    extends CharacterRepresentation

Transient representation based on a BIO characters reader.

Author:
  Jerome Louvel

### Field Summary

### Fields inherited from class org.restlet.representation.Representation

`UNKNOWN_SIZE`

### Constructor Summary

Constructors
Constructor and Description
`ReaderRepresentation(java.io.Reader reader)` Constructor.
`ReaderRepresentation(java.io.Reader reader, MediaType mediaType)` Constructor.
`ReaderRepresentation(java.io.Reader reader, MediaType mediaType, long expectedSize)` Constructor.

### Method Summary

Methods
`java.io.Reader` `getReader()` Returns a characters reader with the representation's content.
`java.lang.String` `getText()` Note that this method relies on `CharacterRepresentation.getStream()`.
`void` `release()` Closes and releases the input stream.
`void` `setReader(java.io.Reader reader)` Sets the reader to use.
`void` `write(java.io.Writer writer)` Writes the representation to a characters writer.

### Methods inherited from class org.restlet.representation.CharacterRepresentation

`getChannel, getStream, write, write`

### Methods inherited from class org.restlet.representation.Representation

`checkDigest, checkDigest, computeDigest, createEmpty, exhaust, getAvailableSize, getDigest, getDisposition, getDownloadName, getExpirationDate, getRange, getSize, isAvailable, isDownloadable, isTransient, setAvailable, setDigest, setDisposition, setDownloadable, setDownloadName, setExpirationDate, setRange, setSize, setTransient`

### Methods inherited from class org.restlet.representation.RepresentationInfo

`getModificationDate, getTag, setModificationDate, setTag`

### Methods inherited from class org.restlet.representation.Variant

`createClientInfo, equals, getCharacterSet, getEncodings, getIdentifier, getLanguages, getLocationRef, getMediaType, includes, isCompatible, setCharacterSet, setEncodings, setIdentifier, setIdentifier, setLanguages, setLocationRef, setLocationRef, setMediaType, toString`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### ReaderRepresentation

    public ReaderRepresentation(java.io.Reader reader)

Constructor.

Parameters:
  `reader` - The representation's stream.

#### ReaderRepresentation

    public ReaderRepresentation(java.io.Reader reader,
                        MediaType mediaType)

Constructor.

Parameters:
  `reader` - The representation's stream.
  `mediaType` - The representation's media type.

#### ReaderRepresentation

    public ReaderRepresentation(java.io.Reader reader,
                        MediaType mediaType,
                        long expectedSize)

Constructor.

Parameters:
  `reader` - The representation's stream.
  `mediaType` - The representation's media type.
  `expectedSize` - The expected reader size in bytes.

### Method Detail

#### getReader

    public java.io.Reader getReader()
                             throws java.io.IOException

Description copied from class: `Representation`
Returns a characters reader with the representation's content. This method is ensured to return a fresh reader for each invocation unless it is a transient representation, in which case null is returned. If the representation has no character set defined, the system's default one will be used.

Specified by:
  `getReader` in class `Representation`
Returns:
  A reader with the representation's content.
Throws:
  `java.io.IOException`

#### getText

    public java.lang.String getText()
                             throws java.io.IOException

Note that this method relies on `CharacterRepresentation.getStream()`. This stream is closed once fully read.

Overrides:
  `getText` in class `Representation`
Returns:
  The representation as a string value.
Throws:
  `java.io.IOException`

#### release

    public void release()

Closes and releases the input stream.

Overrides:
  `release` in class `Representation`

#### setReader

    public void setReader(java.io.Reader reader)

Sets the reader to use.

Parameters:
  `reader` - The reader to use.

#### write

    public void write(java.io.Writer writer)
               throws java.io.IOException

Description copied from class: `Representation`
Writes the representation to a characters writer. This method is ensured to write the full content for each invocation unless it is a transient representation, in which case an exception is thrown.
Note that the class implementing this method shouldn't flush or close the given `Writer` after writing to it as this will be handled by the Restlet connectors automatically.

Specified by:
  `write` in class `Representation`
Parameters:
  `writer` - The characters writer.
Throws:
  `java.io.IOException`